<html>
<head>
	<meta http-equiv="Content-type" content="text/html; charset=utf-8">
	<meta name="viewport" content="width=device-width,initial-scale=1,user-scalable=no">
	<title>XSD validation rules</title>
</head>
<body>
<h1>Validation rules for XML schema definition</h1>
<p>This table provides a series of rules to follow when designing XML schemas for OOTS evidence requirements.</p>
<p>The rules defined in the table were created based on well established and standards of XML declaration schema (UBL, NIEM) and to ease the readability of the final documents.</p>
<table id="example" class="display" style="width:100%">
    <thead>
        <tr>
            <td>ID</td>
            <td>XSD requirement</td>
            <td>Corresponding schematron rule (if any)</td>
            <td>Source </td>
        </tr>
    </thead>
    <tbody>
        <tr>
            <td>1</td>
            <td>A simple type definition MUST be top-level.</td>
            <td>sample_schematron.sch - Line 14</td>
            <td>NIEM Naming and Design Rules (NDR) Specifications </td>
        </tr>
        <tr>
            <td>2</td>
            <td>A simple type MUST have a data definition</td>
            <td>sample_schematron.sch - Line 20</td>
            <td>NIEM Naming and Design Rules (NDR) Specifications </td>
        </tr>
        <tr>
            <td>3</td>
            <td>A complex type definition MUST be top-level.</td>
            <td>sample_schematron.sch - Line 26</td>
            <td>NIEM Naming and Design Rules (NDR) Specifications </td>
        </tr>
        <tr>
            <td>4</td>
            <td>A complex type MUST have a data definition.</td>
            <td>sample_schematron.sch - Line 32</td>
            <td>NIEM Naming and Design Rules (NDR) Specifications </td>
        </tr>
        <tr>
            <td>5</td>
            <td>An element declaration MUST be top-level.</td>
            <td>sample_schematron.sch - Line 38</td>
            <td>NIEM Naming and Design Rules (NDR) Specifications </td>
        </tr>
        <tr>
            <td>6</td>
            <td>An element declaration MUST have a data definition.</td>
            <td>sample_schematron.sch - Line 44</td>
            <td>NIEM Naming and Design Rules (NDR) Specifications </td>
        </tr>
        <tr>
            <td>7</td>
            <td>An element xs:schema MUST have a data definition.</td>
            <td>sample_schematron.sch - Line 50</td>
            <td>NIEM Naming and Design Rules (NDR) Specifications </td>
        </tr>
        <tr>
            <td>8</td>
            <td>The schema MUST define a target namespace.</td>
            <td>sample_schematron.sch - Line 56</td>
            <td>NIEM Naming and Design Rules (NDR) Specifications </td>
        </tr>
        <tr>
            <td>9</td>
            <td>An element xs:schema MUST have an attribute {}version that MUST NOT be empty.</td>
            <td>sample_schematron.sch - Line 62</td>
            <td>NIEM Naming and Design Rules (NDR) Specifications </td>
        </tr>
        <tr>
            <td>10</td>
            <td>An element xs:import MUST have an attribute {}namespace.</td>
            <td>sample_schematron.sch - Line 68</td>
            <td>NIEM Naming and Design Rules (NDR) Specifications </td>
        </tr>
        <tr>
            <td>11</td>
            <td>The name of an XML Schema component defined by the schema must be composed of only the characters uppercase &#39;A&#39; through &#39;Z&#39;, lowercase &#39;a&#39; through &#39;z&#39;, numbers &#39;0&#39; through &#39;9&#39;, underscore, hyphen, and period.</td>
            <td>sample_schematron.sch - Line 74</td>
            <td>NIEM Naming and Design Rules (NDR) Specifications </td>
        </tr>
        <tr>
            <td>12</td>
            <td>Within the schema, any attribute declaration MUST have a name that begins with a lowercase letter (&#39;a&#39;-&#39;z&#39;).</td>
            <td>sample_schematron.sch - Line 80</td>
            <td>NIEM Naming and Design Rules (NDR) Specifications </td>
        </tr>
        <tr>
            <td>13</td>
            <td>Within the schema, an XML Schema component that is not an attribute declaration or proxy type MUST have a name that begins with an upper-case letter (&#39;A&#39;-&#39;Z&#39;).</td>
            <td>sample_schematron.sch - Line 87</td>
            <td>NIEM Naming and Design Rules (NDR) Specifications </td>
        </tr>
        <tr>
            <td>14</td>
            <td>A type definition schema component that does not define a proxy type MUST have a name that ends in &quot;Type&quot;.</td>
            <td>sample_schematron.sch - Line 99</td>
            <td>NIEM Naming and Design Rules (NDR) Specifications </td>
        </tr>
        <tr>
            <td>15</td>
            <td>A schema component with a name that ends in &#39;SimpleType&#39; MUST be a simple type definition.</td>
            <td>sample_schematron.sch - Line 108</td>
            <td>NIEM Naming and Design Rules (NDR) Specifications </td>
        </tr>
        <tr>
            <td>16</td>
            <td>A schema component with a name that ends in &#39;Type&#39; and does not end in &#39;SimpleType&#39; MUST be a complex type definition.</td>
            <td>sample_schematron.sch - Line 112</td>
            <td>NIEM Naming and Design Rules (NDR) Specifications </td>
        </tr>
        <tr>
            <td>17</td>
            <td>An element xs:schema MUST have a title, description, creator, licence, rightsHolder, copyright, status and creation date. These elements can be described in the schema definition using dcterms</td>
            <td></td>
            <td> </td>
        </tr>
        <tr>
            <td>18</td>
            <td>For readability, the XSD schema should first define the different types (simple and complex) before defining elements</td>
            <td></td>
            <td> </td>
        </tr>
        <tr>
            <td>19</td>
            <td>For readability, elements and types should be organised in alphabetical order</td>
            <td></td>
            <td></td>
        </tr>
    </tbody>
</table>
<script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.7.0/jquery.min.js" ></script>
<link rel="stylesheet" type="text/css" href="https://cdn.datatables.net/1.13.4/css/jquery.dataTables.min.css">
<script type="text/javascript" language="javascript" src="https://cdn.datatables.net/1.13.4/js/jquery.dataTables.min.js"></script>
	<script>
	$('#example').DataTable();
	</script>
</body>
</html>